#include "main.h"

void delay_s(unsigned short s)
{
	unsigned short c=s*100;
	while (c)
	{
		c--;
		_delay_ms(10);
	}
}


void putchar( char c )
{
  while( (UCSRA & 1<<UDRE) == 0 );
  UDR = c;
}


void puts( char *s )
{
  while( *s )
    putchar( *s++ );
}


int main( void )
{
  uint i;
  char s[30];

  TCCR0A = 0;
  TCCR0B = 1<<CS02;			//divide by 256
  TIMSK = 1<<TOIE0;			//enable timer interrupt

  UCSRA = 0;				//no U2X, MPC

	// Setze Baud Rate
	UBRRH = (uint8_t)(UART_BAUD_CALC(UART_BAUD_RATE,F_CPU)>>8);
	UBRRL = (uint8_t)UART_BAUD_CALC(UART_BAUD_RATE,F_CPU);

	// Aktiviere Empfangen und Senden + Empfangs-Interrupt 
	UCSRB = (1 << RXEN) | (1 << TXEN)| (1 << RXCIE);

	//Asynchron + 8 Daten Bits + 2 Stoppbits
	UCSRC = (3<<UCSZ0); 


	
	DDRB |= (1<<PB7); 

  sei();
  puts( "RC5-Dekoder:\n\r" );
  for(;;)
  {				// main loop
    cli();
    i = rc5_data;			// read two bytes from interrupt !
    rc5_data = 0;
    sei();
    if( i ){
      //DDRB = i;				// LED output
      putchar(( i >> 11 & 1) + '0');	// Toggle Bit
      putchar(' ');
      itoa( i >> 6 & 0x1F, s, 10);	// Device address
      puts( s );
      putchar(' ');
      itoa((i & 0x3F) | (~i >> 7 & 0x40), s, 10); // Key Code
      puts( s );
      puts( "\n\r" );
    }
  }
}
